/**********************************************************************
 * util.c                                                   August 2005
 *
 * KSSLD: An implementation of SSL/TLS in the Linux Kernel
 * Copyright (C) 2005  NTT COMWARE Corporation.
 *
 * This file based in part on code from LVS www.linuxvirtualserver.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 **********************************************************************/

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/wait.h>

#include "util.h"


long 
kssl_jsleep(long timeout)
{
	u32 start;

	start = jiffies;

	__set_current_state(TASK_INTERRUPTIBLE);
	schedule_timeout(timeout);
	__set_current_state(TASK_RUNNING);

	return start+timeout < jiffies ? 0 : (start+timeout - jiffies) / HZ;
}

u32 
kssl_sleep(u32 sec, u32 usec)
{
	return kssl_jsleep((HZ * sec) + (HZ * usec / 1000000));
}


void
kssl_hexdump(char *in, char *out, size_t in_len)
{
	while(in_len--) {
		snprintf(out, 3, "%02x", *in++ & 0xff);
		out += 2;
	}
}


